# $Id: smtp.py 413 2007-10-19 22:17:06Z jcea $

from globales import monitor

from globales import smtp_server,smtp_server_port,smtp_email_sender,smtp_use_tls,smtp_auth_user,smtp_auth_passwd

import threading
signal=threading.Event()
del threading

def process_queue() :
  @monitor
  def outgoing_pending(conn) :
    emails=conn.get_root()["outgoing emails"]
    if not emails : return None,None  # Nothing to do
    return emails,emails.keys()   # Load all keys in RAM, so we can delete element in the BTree safely while iterating

  emails,pending=outgoing_pending()
  if not pending : return None

  import smtplib
  m=smtplib.SMTP(smtp_server,smtp_server_port)
  m.ehlo()
  if smtp_use_tls :
    m.starttls()
    m.ehlo()   # We need a new "ehlo" because capabilities could have changed
  if smtp_auth_user :
    m.login(smtp_auth_user,smtp_auth_passwd)

# We don't keep the monitor locked because mail sending can be
# fairly slow.
  for k in pending :
    @monitor
    def get_msg(conn,emails,k) :
      destinations,message_obj,error=emails[k]
      text=message_obj[0]
      return destinations,message_obj,text

    @monitor
    def requeue(conn,emails,k,destinations,message,error) :
      emails[k]=(destinations,message,error)

    @monitor
    def del_message(conn,emails,k) :
      del emails[k]

    destinations,message_obj,text=get_msg(emails,k)
    try :
      ret=m.sendmail(smtp_email_sender,destinations,text)
    except :
      import sys
      requeue(emails,k,destinations,message_obj,sys.exc_value)
      continue
    if ret=={} :
      del_message(emails,k)
      continue
    destinations=ret.keys() # The destinations that were not processed
    error=ret.popitem()
    requeue(emails,k,destinations,message,error)

def smtp() :
  import time
  while True :
    try :
      if smtp_server and smtp_server_port and smtp_email_sender :
        process_queue()
    except :
      import sys,traceback
      print >>sys.stderr,"EXCEPCION:",time.ctime()
      print >>sys.stderr,traceback.format_exc()
    signal.wait(60)
    signal.clear()  # Race condition but unimportant

def enqueue(conn,destinations,message) :
  from durus.persistent_list import PersistentList
  emails=conn.get_root()["outgoing emails"]
  if not emails :
    k=0
  else :
    k=emails.get_max_item()[0]+1
  message_obj=PersistentList()
  message_obj.append(message)
  emails[k]=(destinations,message_obj,None)

  signal.set()

