# $Id: upgrade.py 492 2007-11-13 18:39:30Z jcea $

def do(conn) :
  from durus.btree import BTree
  from durus.persistent_dict import PersistentDict
  from durus.persistent_set import PersistentSet
  from durus.persistent_list import PersistentList

  root=conn.get_root()

  if root["version del foro"]=="2007051901" :
    print "Actualizando la base de datos: 2007051901 -> 2007052401"
    root["version del foro"]="2007052401"
    for i in root["hilos"]["hilos"].itervalues() :
      i["numeros"]=BTree()
      n=1
      for j,k in i["mensajes"].items() : # Carga todo el hilo en memoria antes de actualizarlo
        i["numeros"][n]=j
        i["mensajes"][j]=(n,k)
        n+=1
    conn.commit()

  if root["version del foro"]=="2007052401" :
    print "Actualizando la base de datos: 2007052401 -> 2007060501"
    root["version del foro"]="2007060501"
    # Migracion interna...
    conn.commit()

  if root["version del foro"]=="2007060501" :
    print "Actualizando la base de datos: 2007060501 -> 2007060502"
    root["version del foro"]="2007060502"
    metatags=PersistentDict()
    bt=BTree()
    bt[0]=PersistentDict({"nombre":"Varios","num_hilos":root["hilos"]["num_hilos"],"TS2hilo":root["hilos"]["TS2hilo"]})
    del root["hilos"]["TS2hilo"]
    metatags["metatags"]=bt
    metatags["num_metatags"]=1
    root["metatags"]=metatags
    for usuario in root["usuarios"]["usuarios"].itervalues() :
      bt=BTree()
      bt[0]=usuario["punto de lectura no leidos"]
      usuario["punto de lectura no leidos"]=bt
    for hilo in root["hilos"]["hilos"].itervalues() :
      hilo["metatags"]=PersistentSet([0])
    conn.commit()

  if root["version del foro"]=="2007060502" :
    print "Actualizando la base de datos: 2007060502 -> 2007060503"
    root["version del foro"]="2007060503"
    # Migracion interna...
    conn.commit()

  if root["version del foro"]=="2007060503" :
    print "Actualizando la base de datos: 2007060503 -> 2007060504"
    root["version del foro"]="2007060504"
    for usuario in root["usuarios"]["usuarios"].itervalues() :
      for mt in usuario["punto de lectura no leidos"].itervalues() :
        for i in mt.keys() : # Se cargan todas de un golpe, asi que podemos modificar el diccionario
          if not isinstance(i,int) : del mt[i]
    conn.commit()

  if root["version del foro"]=="2007060504" :
    print "Actualizando la base de datos: 2007060504 -> 2007060601"
    root["version del foro"]="2007060601"
    metatags=root["metatags"]["metatags"].keys()
    for usuario in root["usuarios"]["usuarios"].itervalues() :
      plnl=usuario["punto de lectura no leidos"]
      if "num_metatags" in plnl :
        plnl.clear()
        for i in metatags :
          plnl[i]=BTree()
    conn.commit()

  if root["version del foro"]=="2007060601" :
    print "Actualizando la base de datos: 2007060601 -> 2007061501"
    root["version del foro"]="2007061501"
    for mensaje in root["mensajes"]["mensajes"].values() :
      mensaje["texto"]=mensaje["texto"].replace("<br>","<br/>")
    conn.commit()

  if root["version del foro"]=="2007061501" :
    print "Actualizando la base de datos: 2007061501 -> 2007062001"
    root["version del foro"]="2007062001"
    for usuario in root["usuarios"]["usuarios"].itervalues() :
      usuario["OpenID"]=PersistentSet()
    if "jcea" in root["usuarios"]["usuarios"] :
      root["usuarios"]["usuarios"]["jcea"]["OpenID"].add("http://www.argo.es/~jcea/")
    conn.commit()

  if root["version del foro"]=="2007062001" :
    print "Actualizando la base de datos: 2007062001 -> 2007062002"
    root["version del foro"]="2007062002"
    if "alvaro" in root["usuarios"]["usuarios"] :
      root["usuarios"]["usuarios"]["alvaro"]["OpenID"].add("http://alvaro.lopez.myopenid.com/")
    conn.commit()

  if root["version del foro"]=="2007062002" :
    print "Actualizando la base de datos: 2007062002 -> 2007062003"
    root["version del foro"]="2007062003"
    if "alvaro" in root["usuarios"]["usuarios"] :
      root["usuarios"]["usuarios"]["alvaro"]["OpenID"].add("http://perseverantia.com/")
    conn.commit()

  if root["version del foro"]=="2007062003" :
    print "Actualizando la base de datos: 2007062003 -> 2007063001"
    root["version del foro"]="2007063001"
    for mensaje in root["mensajes"]["mensajes"].values() :
      texto_procesado=mensaje["texto"]
      # Ojo, no hacemos "unscape" de los caracteres especiales como el "<" o el "&".
      texto_bruto=texto_procesado.replace("<br/>","")
      mensaje["texto"]=[texto_bruto,texto_procesado]
    conn.commit()

  if root["version del foro"]=="2007063001" :
    print "Actualizando la base de datos: 2007063001 -> 2007070201"
    root["version del foro"]="2007070201"
    root["static"]=PersistentDict()
    root["static"]["avatars"]=BTree()
    conn.commit()

  if root["version del foro"]=="2007070201" :
    print "Actualizando la base de datos: 2007070201 -> 2007070202"
    root["version del foro"]="2007070202"
    for usuario in root["usuarios"]["usuarios"].itervalues() :
      usuario["avatar"]=None
    conn.commit()

  if root["version del foro"]=="2007070202" :
    print "Actualizando la base de datos: 2007070202 -> 2007070401"
    root["version del foro"]="2007070401"
    for metatag in root["metatags"]["metatags"].values() :
      metatag["moderadores"]=[]
    conn.commit()

  if root["version del foro"]=="2007070401" :
    print "Actualizando la base de datos: 2007070401 -> 2007070402"
    root["version del foro"]="2007070402"
    root["static"]["smileys"]=BTree()
    root["smileys"]=PersistentList()
    conn.commit()

  if root["version del foro"]=="2007070402" :
    print "Actualizando la base de datos: 2007070402 -> 2007071101"
    root["version del foro"]="2007071101"
    conn.commit()

  if root["version del foro"]=="2007071101" :
    print "Actualizando la base de datos: 2007071101 -> 2007071102"
    root["version del foro"]="2007071102"
    conn.commit()

  if root["version del foro"]=="2007071102" :
    print "Actualizando la base de datos: 2007071102 -> 2007071103"
    root["version del foro"]="2007071103"
    conn.commit()

  if root["version del foro"]=="2007071103" :
    import time
    weekdayname = ['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun']
    monthname = [None,
                 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
                 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec']
    year, month, day, hh, mm, ss, wd, y, z = time.gmtime()
    ts = "%s, %02d %3s %4d %02d:%02d:%02d GMT" % (
            weekdayname[wd],
            day, monthname[month], year,
            hh, mm, ss)
    print "Actualizando la base de datos: 2007071103 -> 2007071104"
    root["version del foro"]="2007071104"
    for i in root["static"].values() :
      for j,k in i.items() :
        k[0]["last modified"]=ts
        i[j]=k # Los items son diccionarios no persistentes, asi que hay que sobreescribir
    conn.commit()

  if root["version del foro"]=="2007071104" :
    print "Actualizando la base de datos: 2007071104 -> 2007071201"
    root["version del foro"]="2007071201"
    for usuario in root["usuarios"]["usuarios"].itervalues() :
      usuario["email"]=""
    if "jcea" in root["usuarios"]["usuarios"] :
      root["usuarios"]["usuarios"]["jcea"]["email"]="jcea@argo.es"
    conn.commit()

  if root["version del foro"]=="2007071201" :
    print "Actualizando la base de datos: 2007071201 -> 2007071202"
    root["version del foro"]="2007071202"
    conf=PersistentDict()
    conf["thread_len"]=10
    conf["allow_anonymous"]=True
    conf["http_max_clients"]=16
    conf["http_initial_timeout"]=30
    conf["http_keep_alive_timeout"]=5
    conf["openid_support"]=False
    conf["allow_bbcode"]=True
    conf["allow_html"]=True
    conf["allow_avatar_change"]=False

    root["config"]=conf
    conn.commit()

  if root["version del foro"]=="2007071202" :
    print "Actualizando la base de datos: 2007071202 -> 2007071501"
    root["version del foro"]="2007071501"
    conf=root["config"]
    conf["smtp_server"]=""
    conf["smtp_server_port"]=25
    conf["smtp_auth_user"]=""
    conf["smtp_auth_passwd"]=""
    conf["smtp_use_tls"]=False
    conf["smtp_email_sender"]=""
    conn.commit()

  if root["version del foro"]=="2007071501" :
    print "Actualizando la base de datos: 2007071501 -> 2007071502"
    root["version del foro"]="2007071502"
    root["outgoing emails"]=BTree()
    conn.commit()

  if root["version del foro"]=="2007071502" :
    print "Actualizando la base de datos: 2007071502 -> 2007071503"
    root["version del foro"]="2007071503"
    conf=root["config"]
    conf2=PersistentDict()
    conf2.update(conf)
    root["config"]=conf2
    conn.commit()

  if root["version del foro"]=="2007071503" :
    print "Actualizando la base de datos: 2007071503 -> 2007071601"
    root["version del foro"]="2007071601"
    for usuario in root["usuarios"]["usuarios"].itervalues() :
      usuario["new email"]=None
    conn.commit()

  if root["version del foro"]=="2007071601" :
    print "Actualizando la base de datos: 2007071601 -> 2007071602"
    root["version del foro"]="2007071602"
    for usuario in root["usuarios"]["usuarios"].itervalues() :
      if "new email" in usuario :
        del usuario["new email"]
    conn.commit()

  if root["version del foro"]=="2007071602" :
    print "Actualizando la base de datos: 2007071602 -> 2007071901"
    root["version del foro"]="2007071901"
    root["config"]["admin_email_address"]=""
    conn.commit()

  if root["version del foro"]=="2007071901" :
    print "Actualizando la base de datos: 2007071901 -> 2007072601"
    root["version del foro"]="2007072601"
    root["static"]["css"]=BTree()
    root["static"]["js"]=BTree()
    conn.commit()

  if root["version del foro"]=="2007072601" :
    print "Actualizando la base de datos: 2007072601 -> 2007072701"
    root["version del foro"]="2007072701"
    for usuario in root["usuarios"]["usuarios"].itervalues() :
      usuario["monitor metatags"]=BTree()
      usuario["monitor hilos"]=BTree()
    for metatag in root["metatags"]["metatags"].itervalues() :
      metatag["monitor"]=BTree()
    for hilo in root["hilos"]["hilos"].itervalues() :
      hilo["monitor"]=BTree()
    conn.commit()

  if root["version del foro"]=="2007072701" :
    print "Actualizando la base de datos: 2007072701 -> 2007073001"
    root["version del foro"]="2007073001"
    root["config"]["base_url"]=""
    conn.commit()

  if root["version del foro"]=="2007073001" :
    print "Actualizando la base de datos: 2007073001 -> 2007090302"
    root["version del foro"]="2007090302"
    from database import normaliza_nick
    usuarios2nicks={}
    for i,j in root["usuarios"]["usuarios"].items() :
      nick=j["nick"]
      usuarios2nicks[i]=nick
    for hilo in root["hilos"]["hilos"].values() :
      creador=hilo["creador"]
      creador2=usuarios2nicks[normaliza_nick(creador)]
      if creador!=creador2 :
        hilo["creador"]=creador2
      for dummy,msg in hilo["mensajes"].values() :
        autor=msg["autor"]
        autor2=usuarios2nicks[normaliza_nick(autor)]
        if autor!=autor2 :
          msg["autor"]=autor2
    del usuarios2nicks,normaliza_nick
    conn.commit()

  if root["version del foro"]=="2007090302" :
    print "Actualizando la base de datos: 2007090302 -> 2007090601"
    root["version del foro"]="2007090601"
    conn.commit()

  if root["version del foro"]=="2007090601" :
    print "Actualizando la base de datos: 2007090601 -> 2007090602"
    root["version del foro"]="2007090602"
    for metatag in root["metatags"]["metatags"].values() :
      metatag["sticky_threads"]=set()
    conn.commit()

  if root["version del foro"]=="2007090602" :
    print "Actualizando la base de datos: 2007090602 -> 2007090603"
    root["version del foro"]="2007090603"
    root["static"]["icons"]=BTree()
    conn.commit()

  if root["version del foro"]=="2007090603" :
    print "Actualizando la base de datos: 2007090603 -> 2007091302"
    root["version del foro"]="2007091302"
    root["config"]["user_sign_in_mode"]=0  # Only "master" can create new users
    conn.commit()

  if root["version del foro"]=="2007091302" :
    print "Actualizando la base de datos: 2007091302 -> 2007091303"
    root["version del foro"]="2007091303"
    root["usuarios"]["pending_sign_ins"]=BTree()
    conn.commit()

  if root["version del foro"]=="2007091303" :
    print "Actualizando la base de datos: 2007091303 -> 2007091304"
    root["version del foro"]="2007091304"
    if "jcea" in root["usuarios"]["usuarios"] :
      root["usuarios"]["usuarios"]["jcea"]["ts"]="Atlantic/Canary"
    conn.commit()

  if root["version del foro"]=="2007091304" :
    print "Actualizando la base de datos: 2007091304 -> 2007091305"
    root["version del foro"]="2007091305"
    if "jcea" in root["usuarios"]["usuarios"] :
      del root["usuarios"]["usuarios"]["jcea"]["ts"]
      root["usuarios"]["usuarios"]["jcea"]["tz"]="Atlantic/Canary"
    conn.commit()

  if root["version del foro"]=="2007091305" :
    print "Actualizando la base de datos: 2007091305 -> 2007091306"
    root["version del foro"]="2007091306"
    if "jcea" in root["usuarios"]["usuarios"] :
      del root["usuarios"]["usuarios"]["jcea"]["tz"]
    conn.commit()

  if root["version del foro"]=="2007091306" :
    print "Actualizando la base de datos: 2007091306 -> 2007092401"
    root["version del foro"]="2007092401"

    root["config"]["allow_private_messages"]=False

    import database
    for nick,usuario in root["usuarios"]["usuarios"].items() :
      metatag_privado=database.metatag_add(conn,"Mensajes privados de "+usuario["nick"],private=True)
      usuario["metatag_privado"]=metatag_privado
      database.metatag_add_user(conn,metatag_privado,nick)

    conn.commit()

  if root["version del foro"]=="2007092401" :
    print "Actualizando la base de datos: 2007092401 -> 2007092402"
    root["version del foro"]="2007092402"

# Anonymous user has no private messages
    anonimo=root["usuarios"]["usuarios"][""]
    del anonimo["punto de lectura no leidos"][anonimo["metatag_privado"]]

    import database
    for nick,usuario in root["usuarios"]["usuarios"].items() :
      if not nick : continue  # Anonymous user
      metatag_privado=usuario["metatag_privado"]
      if metatag_privado not in usuario["monitor metatags"] :
        database.toggle_monitor_metatag(conn,nick,metatag_privado)

    conn.commit()

  if root["version del foro"]=="2007092402" :
    print "Actualizando la base de datos: 2007092402 -> 2007092403"
    root["version del foro"]="2007092403"
    privados=set()
    for usuario in root["usuarios"]["usuarios"].values() :
      privados.add(usuario["metatag_privado"])
    for num_metatag,metatag in root["metatags"]["metatags"].items() :
      if num_metatag not in privados :
        metatag["public"]=True
    conn.commit()

  if root["version del foro"]=="2007092403" :
    print "Actualizando la base de datos: 2007092403 -> 2007092404"
    root["version del foro"]="2007092404"

    import database
    for nick,usuario in root["usuarios"]["usuarios"].items() :
      if "metatag_privado" in usuario : continue
      metatag_privado=database.metatag_add(conn,"Mensajes privados de "+usuario["nick"],private=True)
      usuario["metatag_privado"]=metatag_privado
      database.metatag_add_user(conn,metatag_privado,nick)
      database.toggle_monitor_metatag(conn,nick,metatag_privado)

    conn.commit()

  if root["version del foro"]=="2007092404" :
    print "Actualizando la base de datos: 2007092404 -> 2007101501"
    root["version del foro"]="2007101501"

    import database
    for usuario in root["usuarios"]["usuarios"].values() :
      nick=database.normaliza_nick(usuario["nick"])
      metatag_privado=usuario["metatag_privado"]
      for dummy,hilo in root["metatags"]["metatags"][metatag_privado]["TS2hilo"].values() :
        if hilo["titulo"]=="[" : continue
        if nick!=database.normaliza_nick(hilo["creador"]) :
          hilo["titulo"]="[%s] %s" %(hilo["creador"],hilo["titulo"])

    conn.commit()

  if root["version del foro"]=="2007101501" :
    print "Actualizando la base de datos: 2007101501 -> 2007101502"
    root["version del foro"]="2007101502"

    import database
    for nick,usuario in root["usuarios"]["usuarios"].items() :
      metatag_privado=usuario["metatag_privado"]
      for dummy,hilo in root["metatags"]["metatags"][metatag_privado]["TS2hilo"].values() :
        while hilo["titulo"][0]=="[" :
          hilo["titulo"]=hilo["titulo"][hilo["titulo"].index("]")+2:]
        if nick!=database.normaliza_nick(hilo["creador"]) :
          hilo["titulo"]="[%s] %s" %(usuario["nick"],hilo["titulo"])

    conn.commit()

  if root["version del foro"]=="2007101502" :
    print "Actualizando la base de datos: 2007101502 -> 2007101503"
    root["version del foro"]="2007101503"

    import database
    for nick,usuario in root["usuarios"]["usuarios"].items() :
      metatag_privado=usuario["metatag_privado"]
      for dummy,hilo in root["metatags"]["metatags"][metatag_privado]["TS2hilo"].values() :
        while hilo["titulo"][0]=="[" :
          hilo["titulo"]=hilo["titulo"][hilo["titulo"].index("]")+2:]
        if nick!=database.normaliza_nick(hilo["creador"]) :
          hilo["titulo"]="[%s] %s" %(usuario["nick"],hilo["titulo"])

    conn.commit()

  if root["version del foro"]=="2007101503" :
    print "Actualizando la base de datos: 2007101503 -> 2007101504"
    root["version del foro"]="2007101504"

    import database
    for nick,usuario in root["usuarios"]["usuarios"].items() :
      metatag_privado=usuario["metatag_privado"]
      for hilo,dummy in root["metatags"]["metatags"][metatag_privado]["TS2hilo"].values() :
        database.toggle_monitor_thread(conn,nick,hilo)

    conn.commit()

  if root["version del foro"]=="2007101504" :
    print "Actualizando la base de datos: 2007101504 -> 2007101701"
    root["version del foro"]="2007101701"

    import database
    for nick,usuario in root["usuarios"]["usuarios"].items() :
      metatag_privado=usuario["metatag_privado"]
      for dummy,hilo in root["metatags"]["metatags"][metatag_privado]["TS2hilo"].values() :
        while hilo["titulo"][0]=="[" :
          hilo["titulo"]=hilo["titulo"][hilo["titulo"].index("]")+2:]
    for nick,usuario in root["usuarios"]["usuarios"].items() :
      metatag_privado=usuario["metatag_privado"]
      for dummy,hilo in root["metatags"]["metatags"][metatag_privado]["TS2hilo"].values() :
        if nick!=database.normaliza_nick(hilo["creador"]) :
          hilo["titulo"]="[%s] %s" %(usuario["nick"],hilo["titulo"])

    conn.commit()

  if root["version del foro"]=="2007101701" :
    print "Actualizando la base de datos: 2007101701 -> 2007101801"
    root["version del foro"]="2007101801"

    try :
      from globales import tz
    except :
      import pytz
      tz=pytz.timezone("Europe/Madrid")
      
    for usuario in root["usuarios"]["usuarios"].values() :
      if "tz" not in usuario :
        usuario["tz"]=tz

    conn.commit()

  if root["version del foro"]=="2007101801" :
    print "Actualizando la base de datos: 2007101801 -> 2007101901"
    root["version del foro"]="2007101901"

    for usuario in root["usuarios"]["usuarios"].values() :
      usuario["tz"]=usuario["tz"].zone

    conn.commit()

  if root["version del foro"]=="2007101801" :
    print "Actualizando la base de datos: 2007101801 -> 2007101901"
    root["version del foro"]="2007101901"

    for usuario in root["usuarios"]["usuarios"].values() :
      usuario["tz"]=usuario["tz"].zone

    conn.commit()

  if root["version del foro"]=="2007101901" :
    print "Actualizando la base de datos: 2007101901 -> 2007101902"
    root["version del foro"]="2007101902"

    root["config"]["tz"]="Europe/Madrid"

    conn.commit()

  if root["version del foro"]=="2007101902" :
    print "Actualizando la base de datos: 2007101902 -> 2007102901"
    root["version del foro"]="2007102901"

    root["config"]["google_verification"]="giyfU5B1t9DnDYxPERuHroMlWI/EcZW5+wVPnhAthf8="

    conn.commit()

  if root["version del foro"]=="2007102901" :
    print "Actualizando la base de datos: 2007102901 -> 2007110501"
    root["version del foro"]="2007110501"

    grupos=PersistentDict()
    grupos["grupos"]=PersistentDict()
    grupos["num_grupos"]=0
    root["grupos"]=grupos

    for usuario in root["usuarios"]["usuarios"].values() :
      usuario["grupos"]=set()

    conn.commit()

  if root["version del foro"]=="2007110501" :
    print "Actualizando la base de datos: 2007110501 -> 2007110502"
    root["version del foro"]="2007110502"

    grupos=PersistentDict()  # Limpieza
    grupos["grupos"]=PersistentDict()
    grupos["num_grupos"]=0
    root["grupos"]=grupos

    conn.commit()

  if root["version del foro"]=="2007110502" :
    print "Actualizando la base de datos: 2007110502 -> 2007110503"
    root["version del foro"]="2007110503"

    for metatag in root["metatags"]["metatags"].values() :
      metatag["usuarios moderadores"]=metatag["moderadores"]
      metatag["grupos moderadores"]=[]
      del metatag["moderadores"]
    conn.commit()

  if root["version del foro"]=="2007110503" :
    print "Actualizando la base de datos: 2007110503 -> 2007110504"
    root["version del foro"]="2007110504"

    usuarios=root["usuarios"]["usuarios"]
    for num_grupo,grupo in root["grupos"]["grupos"].items() :
      for usuario in grupo["usuarios"] :
        usuarios[usuario]["grupos"].add(num_grupo)
        usuarios[usuario]._p_note_change()  # MUTABLE!!

    conn.commit()

  if root["version del foro"]=="2007110504" :
    print "Actualizando la base de datos: 2007110504 -> 2007110505"
    root["version del foro"]="2007110505"

    for metatag in root["metatags"]["metatags"].values() :
      metatag["grupos moderadores"]=set(metatag["grupos moderadores"])
    conn.commit()

  if root["version del foro"]=="2007110505" :
    print "Actualizando la base de datos: 2007110505 -> 2007110506"
    root["version del foro"]="2007110506"

    usuarios=root["usuarios"]["usuarios"]
    for usuario in usuarios.values() :
      usuario["grupos"].clear()

    from database import normaliza_nick
    for num_grupo,grupo in root["grupos"]["grupos"].items() :
      for i in grupo["usuarios"] :
        usuarios[normaliza_nick(i)]["grupos"].add(num_grupo)
    del normaliza_nick

    conn.commit()

  if root["version del foro"]=="2007110506" :
    print "Actualizando la base de datos: 2007110506 -> 2007110601"
    root["version del foro"]="2007110601"

    from database import metatag_add_user
    for num_grupo,grupo in root["grupos"]["grupos"].items() :
      mt=grupo["metatag_privado"]
      for usuario in grupo["usuarios"] :
        metatag_add_user(conn,mt,usuario)
    del metatag_add_user

    conn.commit()

  if root["version del foro"]=="2007110601" :
    print "Actualizando la base de datos: 2007110601 -> 2007110801"
    root["version del foro"]="2007110801"

    metatags_publicos=PersistentSet()
    root["metatags"]["publicos"]=metatags_publicos

    for num_metatag,metatag in root["metatags"]["metatags"].items() :
      if "public" in metatag :
        del metatag["public"]
        metatags_publicos.add(num_metatag)

    conn.commit()

  if root["version del foro"]=="2007110801" :
    print "Actualizando la base de datos: 2007110801 -> 2007111301"
    root["version del foro"]="2007111301"

    categorias=PersistentList()
    publicos=list(root["metatags"]["publicos"])
    publicos.sort()
    for i in publicos :
      categorias.append([i])
    root["metatags"]["categorias"]=categorias
    conn.commit()

  if root["version del foro"]=="2007111301" :
    print "Actualizando la base de datos: 2007111301 -> 2007111302"
    root["version del foro"]="2007111302"

    categorias=PersistentList()
    publicos=list(root["metatags"]["publicos"])
    publicos.sort()
    for i in publicos :
      categorias.append([i])
    root["metatags"]["categorias"]=categorias
    conn.commit()

