# $Id: init.py 414 2007-10-19 22:18:14Z jcea $

"""Inicializacion del frontend web"""

def main() :
  import globales

  import os,sys
  directorio_padre=os.path.split(os.getcwd())[0]  # Directorio padre
  sys.path.append(os.path.join(directorio_padre,"backend"))

  for i in os.walk(directorio_padre) :
    if i[0].endswith("durus-berkeleydbstorage") : continue
    if i[2] :
      for j in i[2] :
        if j.endswith(".py") :
          f=os.path.join(i[0],j)
          cabecera=open(f).readline().strip().split()
          version=0
          for k in cabecera :
            try :
              version=int(k)
              break
            except :
              pass
          if version>globales.version :
            print f,version
            globales.version=version

  import storage
  dummy,dummy,monitor=storage.storage_and_monitor(os.path.join(os.path.pardir,"backend","db"))
  globales.monitor=monitor

  import database

  database.init_database(monitor)

  if globales.openid_support :
    import openid  # Nos aseguramos de tener la libreria

  if globales.allow_avatar_change :
    from PIL import Image # Nos aseguramos de tener la libreria

  @monitor
  def inicializa(conn,masterkey) :
    if not conn.get_root()["usuarios"]["num_usuarios"] :
      print "Importando usuarios..."
      import os.path
      if os.path.exists("claves.backup") :      
        f=open("claves.backup")
        for i in f :
          i=i.split()
          if len(i)==1 : i=["",i[0]]
          print i
          database.usuario_add(conn,i[0],None,clave=i[1])
        f.close()

    master=conn.get_root()["usuarios"]["usuarios"].get("master",None)
    if master :
      assert master["clave"]==masterkey
    else :
      database.usuario_add(conn,"master",None,clave=masterkey)

    if not database.usuario_get(conn,"") :
      database.usuario_add(conn,"",None)

    if globales.admin_email_address and globales.smtp_server and globales.smtp_server_port :
      import smtp
      smtp.enqueue(conn,[globales.admin_email_address],"Subject: Arranque CPIF\r\n\r\nArrancamos CPIF")

  inicializa(masterkey=sys.argv[1])

# Lanzamos el servicio de envios de mensajes
# electronicos en un hilo separado
  from smtp import smtp
  import threading
  t=threading.Thread(target=smtp)
  t.setDaemon(True)
  t.start()

# Lanzamos el servidor web en un hilo separado
  from servidor_web import servidor_web
  import threading
  t=threading.Thread(target=servidor_web)
  t.setDaemon(True)
  t.start()

# Permanecemos web mientras el
# servidor web siga vivo.
  import time
  while t.isAlive() :
    time.sleep(0.1)

  t.join()

if __name__=="__main__" :
  main()

