# $Id: skins.py 492 2007-11-13 18:39:30Z jcea $

import globales

from calendario import daydate,hourdate

available_skins = {}

skin_files = {
    'header':         'header.html',
    'body_thread':    'body_show_thread.html',
    'body_thread_ro':    'body_show_thread_ro.html',
    'body_thread_anonymous':    'body_show_thread_anonymous.html',
    'avatar':         'avatar.html',
    'thread_entry':   'body_show_thread_entry.html',
    'thread_entry_ro':   'body_show_thread_entry_ro.html',
    'thread_entry_anonymous':   'body_show_thread_entry_anonymous.html',
    'thread_first':   'body_show_thread_first.html',
    'thread_prev':    'body_show_thread_prev.html',
    'thread_num':     'body_show_thread_num.html',
    'thread_num_inactive':     'body_show_thread_num_inactive.html',
    'thread_next':    'body_show_thread_next.html',
    'thread_last':    'body_show_thread_last.html',
    'thread_mon':     'body_show_thread_mon.html',
    'thread_unmon':   'body_show_thread_unmon.html',
    'new_user':       'body_new_user.html',
    'generic':        'body_generic.html',
    'body':           'body_threadlist.html',
    'body_anonymous': 'body_threadlist_anonymous.html',
    'body_metatags':  'body_metatags.html',
    'metatag':        'body_metatags_metatag.html',
    'metatag_anonymous':      'body_metatags_metatag_anonymous.html',
    'metatag_unread': 'body_metatags_metatag_unread.html',
    'metatag_mon':    'body_metatags_metatag_mon.html',
    'metatag_unmon':  'body_metatags_metatag_unmon.html',
    'stickies title':    'body_threadlist_stickies.html',
    'sticky':    'sticky.html',
    'read only':    'read_only.html',
    'thread_unread':  'body_threadlist_thread_unread.html',
    'thread_anonymous':       'body_threadlist_thread_anonymous.html',
    'thread':         'body_threadlist_thread.html',
    'group_date':     'body_threadlist_group.html',
    'link_logout':    'link_logout.html',
    'link_login':     'link_login.html',
    'form_login_err': 'form_login_err.html',
    'form_login':     'form_login.html',
    'profile':        'profile.html',
    'footer':         'footer.html',
    }

urls = {
    '/':                       ['metatags'],
    '/indice':                 ['group_date', 'threads', 'threads'],
    '/hilo':                   ['thread_entries'],
    '/nuevo_usuario':          ['new_user'],
    '/login_err':              ['login_err'],
    '/LOGIN':                  ['login'],
    '/perfil':                 ['profile'],
    '/error':                  [],
    '/nuevo_usuario_POST':     [],
    '/perfil_POST':            [],
    '/toggle_readonly':        [],
    '/toggle_sticky':          [],
    '/new_user_confirmation':  [],
    }

import os
from globales import monitor
sdir = os.path.join(os.path.curdir,"skins")
print "Inicializo los skins"
for dir in os.listdir(sdir):
  control = True
  for j in skin_files.values():
    if not os.path.exists(os.path.join(sdir, dir, j)):
      control = False
  if control:
    available_skins[dir]= {}

    css=open(os.path.join(sdir,dir,"css.css")).read()
    js=open(os.path.join(sdir,dir,"js.js")).read()
    @monitor
    def save_css_js(conn,css,js) :
      from database import save_static
      ret=save_static(conn,"css",css,{"content-type":"text/css"})
      return (ret,save_static(conn,"js",js,{"content-type":"text/javascript"}))
    css,js=save_css_js(css,js)
    replacement={"***CSS***":"/static/css/%s" %css,
                 "***JS***":"/static/js/%s" %js}

    icons = {
        "icon sticky": os.path.join(sdir,dir,"icons","phpBB2","folder_announce.gif"),
        "icon ro": os.path.join(sdir,dir,"icons","phpBB2","topic_lock.gif"),
        "icon unread": os.path.join(sdir,dir,"icons","phpBB2","icon_newest_reply.gif"),
        }
    @monitor
    def save_icons(conn,icons):
      from database import save_static,check_image
      ret = {}
      for icon_name,file in icons.iteritems():
        icon = open(file).read()
        result,metadata = check_image(icon)
        ret[icon_name] = "/static/icons/%s" %save_static(conn,"icons",icon,metadata)
      return ret
    icons = save_icons(icons)

    for skin,file in skin_files.items():
      f=open(os.path.join(sdir,dir,file))
      data=f.read()
      for k,v in replacement.iteritems() :
        data=data.replace(k,v)
      available_skins[dir][skin] = data
      f.close()

if "default" not in available_skins: # FIXME: an~adir un skin de fallback?
  raise "Error, no tenemos el skin por defecto!!"
print available_skins.keys()

class Skin:
  def __init__(self,url,user=None,headers={}) :
    self._skin = "default"
    self._path = url
    self._url = "/%s" % url[0]
    self._style = ["odd","even"]
    self._text = []
    self._user = user
    self._header_if_none_match=headers.get("if-none-match",None)
    from globales import google_verification
    self._dict = {
        "version": globales.version,
        "page_title": "cpif",
        "user": user,
        "generic_message": "Algo va mal",
        "calendar":"",
        "google_verification":google_verification,
        }
    if self._user:
      self._dict["auth"] = available_skins[self._skin]["link_logout"] % { "link_auth": "/logout", "user": self._user }
    else:
      tmp = [] if self._path[0] == "LOGIN" or self._path[0] == "login_err" else self._path
      self._dict["auth"] = available_skins[self._skin]["link_login"] % { "link_auth": "/LOGIN/%s" % "/".join(tmp) if self._path else "/LOGIN/" }

  def set_skin(self,skin):
    if skin in available_skins:
      self._skin=skin
      return True
    return None

  def load_url(self,url):
    self._url = "/%s" % url[0]
    self._path = url

  def load_dict(self,d):
    for key,val in d.iteritems():
      self._dict[key]=val

  def set_text(self,text):
    self._text.append(text)

  def show_thread(self):
    """Format some entries inside a thread"""
    first_post, num_msgs, messages = self._dict.pop("messages")
    thread_num = self._dict.get("thread_num")
    metatag = self._dict.get("metatag",None)
    tz=self._dict["tz"]
    for msg_num,author,date,text,avatar in messages:
      format = self._style.pop(0)
      self._style.append(format)
      if self._user:
        aux = available_skins[self._skin]['thread_entry']
        if self._dict["read only"]:
          aux = available_skins[self._skin]['thread_entry_ro']
      else:
        aux = available_skins[self._skin]['thread_entry_anonymous']
      if avatar:
        d = {
            "avatar": "/static/avatars/%s" % avatar[0],
            "author": author,
            "width" : avatar[1][0],
            "height": avatar[1][1]
        }
        avatar = available_skins[self._skin]['avatar'] % d
      else:
        avatar = ""

      aux = aux % {"msg_num":msg_num, "author":author,
          "date":hourdate(date,tz),
          "text":text,"format":format,
          "avatar": avatar,
          "read only": available_skins[self._skin]["read only"] % icons
        }
      self.set_text(aux)

    from globales import thread_len

    aux = []
    if first_post!=1 :
      if first_post > thread_len * 2 :
        aux.append(available_skins[self._skin]['thread_first'] % {'link': '/hilo/%d' % thread_num})
      aux.append(available_skins[self._skin]['thread_prev'] % {'link': '/hilo/%d/%d' % (thread_num,first_post-thread_len)})
    
    curr = first_post

    for i in range(-2,2):
      curr = first_post + i*thread_len
      if first_post==curr:
        aux.append(available_skins[self._skin]['thread_num_inactive'] % {'num': first_post/thread_len +1})
      elif curr > 0 and curr <= num_msgs:
        aux.append(available_skins[self._skin]['thread_num'] % {'link': '/hilo/%d/%d' % (thread_num,curr), 'num': curr / thread_len +1})

    if first_post + thread_len <= num_msgs:
      aux.append(available_skins[self._skin]['thread_next'] % {'link': '/hilo/%d/%d' % (thread_num,first_post+thread_len)})
    if first_post + thread_len * 2 <= num_msgs:
      aux.append(available_skins[self._skin]['thread_last'] % {'link': '/hilo/%d/%d' % (thread_num, 1 + (num_msgs/thread_len) * thread_len)})
    self._dict["nav"]="".join(aux)
    aux = available_skins[self._skin]['thread_unmon'] if self._dict["monitor"] else available_skins[self._skin]['thread_mon']
    self._dict["mon"] = aux % self._dict

  
  def list_metatags(self):
    """Format the thread list"""
    categorias_list = self._dict.pop("metatags",None)
    for m_list in categorias_list :
      if len(m_list)>1 :
        self.set_text(m_list[0])
        m_list=m_list[1:]
      for id, title, nr, mon in m_list:
        format = self._style.pop(0)
        self._style.append(format)
        if self._dict["user"]:
          mon = available_skins[self._skin]['metatag_unmon'] if mon else available_skins[self._skin]['metatag_mon']
          mon = mon % { "metatag_num": id }
          if nr:
            aux = available_skins[self._skin]['metatag_unread'] % {"title":title, "format": format, "link": "/indice/%d" % id, "mon": mon, "icon unread": icons["icon unread"]}
          else:
            aux = available_skins[self._skin]['metatag'] % {"title":title, "format": format, "link": "/indice/%d" % id, "mon": mon}
        else:
          aux = available_skins[self._skin]['metatag_anonymous'] % {"title":title, "format": format, "link": "/indice/%d" % id}
        self.set_text(aux)

  def list_threads(self):
    """Format the thread list"""
    threads = ["stickies", "threads"]
    metatag = self._dict.get("metatag",None)
    tz=self._dict["tz"]
    thread_len=globales.thread_len

    # The monitoring of the metatag:
    mon = available_skins[self._skin]['metatag_unmon'] if self._dict["monitor"] else available_skins[self._skin]['metatag_mon']
    mon = mon % { "metatag_num": metatag }
    self._dict["mon"] = mon

    for list_type in threads:
      t_list = self._dict.pop(list_type,None)
      for date,threads in t_list:
        if list_type == "stickies":
          self.set_text(available_skins[self._skin]['stickies title'])
        else:
            self.set_text(available_skins[self._skin]['group_date'] % {'group_date':daydate(date,tz)})
        for thread, title, ts, nr, nr_point, n_msgs, mon, ro in threads:
          format = self._style.pop(0)
          self._style.append(format)
          if list_type == "stickies":
            format = "stick%s" % format
          read_only = available_skins[self._skin]['read only'] if ro else ""
          read_only = read_only % icons
          sticky = available_skins[self._skin]['sticky'] if list_type == "stickies" else ""
          sticky = sticky % icons
          if self._dict["user"]:
            mon =  available_skins[self._skin]['thread_unmon'] if mon else available_skins[self._skin]['thread_mon']
            mon = mon % { "thread_num": thread }
            if nr:
              page = ((nr[0] - 1) / thread_len)  * thread_len + 1
              aux = available_skins[self._skin]['thread_unread'] % {"title":title,
                  "link": "/hilo/%d" %(thread),
                  "link_notread": "/hilo/%d/%d#m%d" %(thread,page,nr_point),
                  "t_date": hourdate(ts,tz),
                  "format": format,
                  "not_read": nr_point,
                  "t_replies": n_msgs,
                  "mon":mon,
                  "read only": read_only,
                  "icon unread": icons["icon unread"],
                  "sticky": sticky,
                  }
            else:
              aux = available_skins[self._skin]['thread'] % {"title":title,
                  "link": "/hilo/%d" %thread,
                  "t_date":hourdate(ts,tz),
                  "format": format,
                  "t_replies": n_msgs,
                  "mon":mon,
                  "read only": read_only,
                  "sticky": sticky,
                  }
          else:
            aux = available_skins[self._skin]['thread_anonymous'] % {"title":title,
                "link": "/hilo/%d" %thread,
                "t_date":hourdate(ts,tz),
                "format": format,
                "t_replies": n_msgs,
                "read only": read_only,
                "sticky": sticky,
                }
          self.set_text(aux)

  def _header(self):
    return available_skins[self._skin]['header'] % self._dict
  
  def _body(self,title=None):
    metatag = self._dict.get("metatag",None)
    if "metatags" in urls[self._url]:
      self.list_metatags()
      aux = available_skins[self._skin]['body_metatags']
    elif "threads" in urls[self._url]:
      self.list_threads()
      self._dict["link_mark_as_read"] = "/todo_leido/%d" % metatag
      if self._user:
        self._dict["link_form_new_thread"] = "/nuevo_hilo_POST/%d" % metatag
        aux = available_skins[self._skin]['body']
      else:
        aux = available_skins[self._skin]['body_anonymous']
    elif "thread_entries" in urls[self._url]:
      self.show_thread()
      self._dict["link_metatag"] = "/indice/%d" % metatag
      if self._user:
        self._dict["link_form_new_post"] = "/nuevo_post_POST/%d/%d" %(metatag,self._dict["thread_num"])
        aux = available_skins[self._skin]['body_thread']
        if self._dict["read only"]:
          self._dict["read only"] = available_skins[self._skin]['read only'] % icons
          aux = available_skins[self._skin]['body_thread_ro'] 
      else:
        aux = available_skins[self._skin]['body_thread_anonymous']
    elif "profile" in urls[self._url]:
      self._dict["body"] = available_skins[self._skin]['profile']
      if self._dict["avatar"]:
        self._dict["profile avatar"] = available_skins[self._skin]['avatar'] % {"avatar": "/static/avatars/"+self._dict["avatar"], "author": self._dict["user"], "width": "", "height": ""} 
      else:
        self._dict["profile avatar"]=""
      aux = available_skins[self._skin]['generic'] % self._dict 
    elif "login" in urls[self._url]:
      self._dict["body"] = available_skins[self._skin]['form_login']
      aux = available_skins[self._skin]['generic'] % self._dict 
      self._dict["link_form_login"] = "/LOGIN/%s" % "/".join(self._path[1:])
    elif "login_err" in urls[self._url]:
      self._dict["body"] = available_skins[self._skin]['form_login_err']
      aux = available_skins[self._skin]['generic'] % self._dict
      self._dict["link_form_login"] = "/LOGIN/%s" % "/".join(self._path[1:])
    elif "new_user" in urls[self._url]:
      self._dict["body"] = available_skins[self._skin]['new_user']
      aux = available_skins[self._skin]['generic'] % self._dict
    else: # Removed the stop, error, etc urls from there, they (at the moment) are all tall the same
      aux = available_skins[self._skin]['generic']
      self.set_text(self._dict.get('generic_message',None))

    ret = self._dict # Pillamos el diccionario a devolver
    ret['body'] = "\r\n".join(self._text) # Aniado el texto
    return aux % ret

  def _footer(self):
    return available_skins[self._skin]['footer'] % self._dict

  def web(self,code=200):
    headers={}
    text="\r\n".join([self._header(),self._body(),self._footer()])
    if code==200 :
      import md5
      etag='"%s"' %md5.new(text).hexdigest()
      if_none_match=self._header_if_none_match
      if if_none_match :
        for i in if_none_match.split(",") :
          if etag==i.strip() :
            return (304,headers,"")
      headers["ETag"]=etag
    headers["Content-Type"]="text/html; charset=utf-8"
    return (code, headers, text)

