# $Id: url_nuevo_usuario_POST.py 363 2007-09-13 11:41:52Z jcea $

from globales import monitor
from globales import user_sign_in_mode

@monitor
def gestiona_url(conn,handler,path,usuario) :
  if len(path)!=1 : return None

  import skins
  pagina = skins.Skin(path,usuario)
  pagina.load_dict({"page_title": "cpif - Alta exitosa"})
  
  if (usuario!="master") and (user_sign_in_mode==0) :
    pagina.load_url(["error"])
    pagina.load_dict({"generic_message": "<h1>Solo el usuario master puede crear nuevos usuarios</h1>"})
    return (pagina.web())

  import cgi
  ctype,pdict=cgi.parse_header(handler.headers.getheader('content-type'))
  cuerpo=cgi.FieldStorage(fp=handler.rfile,headers=handler.headers,environ={'REQUEST_METHOD':'POST'},keep_blank_values=1)
  nick=cuerpo.getfirst("usuario")
  clave1=cuerpo.getfirst("clave1")
  clave2=cuerpo.getfirst("clave2")
  email=cuerpo.getfirst("email")
  try :
    nick=nick.strip()
    clave1=clave1.strip()
    clave2=clave2.strip()
    email=email.strip()
  except :
    nick="" # Generate an error

  if not (nick and clave1 and clave2 and email) : # Comprobamos el caso de campos inexistentes
    pagina.load_url(["error"])
    pagina.load_dict({"generic_message": "<h1>No puedes dejar ningun campo no opcional en blanco</h1>"})
    return pagina.web()

  OpenIDs=set()
  for i in xrange(1,6) :
    OpenID=cuerpo.getfirst("OpenID%d" %i)
    if OpenID : # Comprobamos el caso de campos inexistentes
      OpenID=OpenID.strip()
      if OpenID :
        if '"' in OpenID : # XSS
          pagina.load_url(["error"])
          pagina.load_dict({"generic_message": "<h1>Caracteres extra&ntilde;os en los servidores OpenID</h1>"})
          return pagina.web()
        OpenIDs.add(OpenID)

  for i in ['"',"'",'<','>','&'] :
    if i in nick :
      pagina.load_url(["error"])
      pagina.load_dict({"generic_message": "<h1>Caracteres extra&ntilde;os en el nombre de usuario</h1>"})
      return pagina.web()

  if clave1!=clave2 :
    pagina.load_url(["error"])
    pagina.load_dict({"generic_message": "<h1>Las claves introducidas no coinciden</h1>"})
    return (pagina.web())

  for i in ['"',"'",'<','>','&',' ','\t'] : # Deberiamos poner realmente una lista de los permitidos
    if i in email:
      error="<h1>Caracteres extra&ntilde;os en la direccion</h1>"
      pagina.load_url(["error"])
      pagina.load_dict({"generic_message": "<h1>Caracteres extra&ntilde;os en la direcci&oacute;n de correo</h1>"})
      return pagina.web()

  import database
  if database.usuario_verifica(conn,nick=nick) :
    pagina.load_url(["error"])
    pagina.load_dict({"generic_message": "<h1>El usuario ya existe</h1>"})
    return (pagina.web())

  if usuario=="master" :
    database.usuario_add(conn,nick,None,clave=clave1,email=email,OpenIDs=OpenIDs)
    pagina.load_dict({"generic_message": "<h1>Alta exitosa</h1>"})
  else :
    nonce=database.usuario_add_pending(conn,nick,None,clave=clave1,email=email,OpenIDs=OpenIDs)

    from globales import smtp_email_sender,base_url
    texto=["From: %s" %smtp_email_sender]
    texto.append("To: %s" %email)
    texto.append("Subject: Confirmacion de alta de usuario")
    texto.append("")
    texto.append("Para confirmar tu usuario, pulsa sobre el")
    texto.append("siguiente enlace:")
    texto.append("")
    texto.append("%s/new_user_confirmation/%s" %(base_url,nonce))

    import smtp
    smtp.enqueue(conn,[email],"\r\n".join(texto))

    pagina.load_dict({"generic_message": "<h1>Se le ha enviado un mensaje de correo electr&oacute;nico. Siga sus instrucciones.</h1>"})

  return (pagina.web())

