# $Id: url_perfil_POST.py 405 2007-10-19 04:50:12Z jcea $

from globales import monitor

@monitor
def gestiona_url(conn,handler,path,usuario) :
  if not usuario : # Acceso anonimo
    return None

  if len(path)!=2 : return None

  import database
  usuario_pedido=path[1]
  usuario_pedido_normalizado=database.normaliza_nick(usuario_pedido)

  if (usuario!="master") and (usuario_pedido_normalizado!=database.normaliza_nick(usuario)) :
    return None

  import skins
  pagina = skins.Skin(path,usuario)
  pagina.load_dict({"page_title": "cpif - Cambio de perfil exitoso"})
  
  import cgi
  ctype,pdict=cgi.parse_header(handler.headers.getheader('content-type'))
  cuerpo=cgi.FieldStorage(fp=handler.rfile,headers=handler.headers,environ={'REQUEST_METHOD':'POST'},keep_blank_values=1)
  clave1=cuerpo.getfirst("clave1")
  clave2=cuerpo.getfirst("clave2")
  new_email=cuerpo.getfirst("new_email")
  TZ=cuerpo.getfirst("TZ")
  avatar=cuerpo.getfirst("avatar")

  # Comprobamos el caso de campos inexistentes
  if clave1==None or clave2==None or new_email==None or avatar==None or TZ==None :
    return None

  import pytz
  try :
    pytz.timezone(TZ)  # Comprobamos si esa zona es valida
  except :
    pagina.load_url(["error"])
    pagina.load_dict({"generic_message": "<h1>La zona horaria especificada es inv&aacute;lida</h1>"})
    return pagina.web()
   
  clave1=clave1.strip()
  clave2=clave2.strip()
  OpenIDs=set()
  for i in xrange(1,6) :
    OpenID=cuerpo.getfirst("OpenID%d" %i)
    if OpenID : # Comprobamos el caso de campos inexistentes
      OpenID=OpenID.strip()
      if OpenID :
        if '"' in OpenID : # XSS
          pagina.load_url(["error"])
          pagina.load_dict({"generic_message": "<h1>Caracteres extra&ntilde;os en los servidores OpenID</h1>"})
          return pagina.web()
        OpenIDs.add(OpenID)

  if clave1!=clave2 :
    pagina.load_url(["error"])
    pagina.load_dict({"generic_message": "<h1>Las claves introducidas no coinciden</h1>"})
    return (pagina.web())

  import database
  if not database.usuario_verifica(conn,nick=usuario_pedido) :
    pagina.load_url(["error"])
    pagina.load_dict({"generic_message": "<h1>El usuario NO existe</h1>"})
    return (pagina.web())

  if avatar :
    error=database.avatar_update(conn,usuario_pedido,avatar)
    if error :
      pagina.load_url(["error"])
      pagina.load_dict({"generic_message": "<h1>%s</h1>" %error})
      return (pagina.web())

  new_email=new_email.strip()
  if new_email :
    from globales import smtp_email_sender,base_url
    nonce=database.usuario_ask_new_email(conn,usuario_pedido,new_email)
    texto=["From: %s" %smtp_email_sender]
    texto.append("To: %s" %new_email)
    texto.append("Subject: Confirmacion de cambio de correo electronico")
    texto.append("")
    texto.append("Autentifiquese en el foro y, despues, pulse sobre el")
    texto.append("siguiente enlace:")
    texto.append("")
    texto.append("%s/email_confirmation/%s" %(base_url,nonce))

    import smtp
    smtp.enqueue(conn,[new_email],"\r\n".join(texto))


  database.usuario_update(conn,usuario_pedido,clave=clave1,OpenIDs=OpenIDs,TZ=TZ)

  pagina.load_dict({"generic_message": "<h1>Cambio de perfil exitoso</h1>"})
  return pagina.web()

