# $Id: url_sitemap_xml.py 392 2007-10-15 17:26:16Z jcea $

url_aliases=["sitemap.xml"]

from globales import monitor

from globales import base_url,thread_len

@monitor
def gestiona_url(conn,handler,path,usuario) :
  if len(path)!=1 : return None

  # Vemos que metatags puede ver el usuario anonimo
  metatags=conn.get_root()["usuarios"]["usuarios"][""]["punto de lectura no leidos"].keys()  # Usuario anonimo

  hilos_ya_publicados=set()

  import time

  antiguo=time.time()-86400*14  # Dos semanas

  ret=['<?xml version="1.0" encoding="utf-8" ?>']
  ret.append('<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">')

  for metatag in metatags :
    for ts,hilo in conn.get_root()["metatags"]["metatags"][metatag]["TS2hilo"].items_backward() :
      if ts<antiguo : break
      num_hilo,hilo=hilo
      if num_hilo in hilos_ya_publicados : continue
      hilos_ya_publicados.add(num_hilo)
      num_mensajes=hilo["num_mensajes"]
      ret.append("<url>")
      pag=thread_len*((num_mensajes-1)/thread_len)
      ret.append("<loc>%s/hilo/%d%s</loc>" %(base_url,num_hilo,"" if not pag else "/%d" %(pag+1)))
      ret.append(time.strftime("<lastmod>%Y-%m-%dT%H:%M:%SZ</lastmod>",time.gmtime(hilo["TS"])))
      ret.append("<changefreq>hourly</changefreq>")
      ret.append("<priority>0.5</priority>")
      ret.append("</url>")
  ret.append('</urlset>')

  return (200,{"Content-Type":"text/xml; charset=utf-8"},
    "\r\n".join(ret))

